#!/usr/contrib/bin/perl
#####################################################
#                                                   #
# PARSELOG - A Log file parsing routine which is    #
# intended to allow firewall messages (and others   #
# by example) to be analyzed and collected into a   #
# set of compacted files which show patterns of     #
# use and potentially ab-use.                       #
#                                                   #
# This version is based on the logging output       #
# of the cisco PIX firewall.  Later I will port     #
# this to Firewall-1 and possibly others.           #
#                                                   #
# Written by: Bob Konigsberg September 1998         #
#                                                   #
# Revision history:                                 #
# 1.0 Basic message separation routines             #
#     and initial parsing efforts.                  #
#                                                   #
# NOTE - This file is NOT a finished product.  It   #
#        still has flaws which I hope to fix in     #
#        the next few months, but it should help    #
#        you get an idea of how to adapt this for   #
#        your own use.  If you do something cool    #
#        or interesting with this, let me know.     #
#        Good luck - BobK@networkeval.com           #
#
#####################################################

#
# Open initial input files - Later change this to a command line
# argument to process older files.
#
# Open the file /var/adm/syslog/loglist and take the last entry from it
# which would be the previous day's logs.  Process these.
open (LOGLIST, "/var/adm/syslog/loglist");
while (<LOGLIST>) 
	{
	chomp;
	@filelist[$i]=$_;
	$i++;
	};
$i--;
print($filelist[$i],"\n");

open (SYSLOG, $filelist[$i]);
open (TCPIN, ">>/var/adm/syslog/log.TCPIN");
open (TCPOUT, ">>/var/adm/syslog/log.TCPOUT");
open (JAVA, ">>/var/adm/syslog/log.JAVA");
open (UDPIN, ">>/var/adm/syslog/log.UDPIN");
open (ICMPIN, ">>/var/adm/syslog/log.ICMP");
open (NETADMIN, ">>/var/adm/syslog/log.NETADMIN");
open (SYSADMIN, ">>/var/adm/syslog/log.SYSADMIN");
open (PIXADMIN, ">>/var/adm/syslog/log.PIXADMIN");
open (SMTP, ">>/var/adm/syslog/log.SMTP");
open (XLATE, ">>/var/adm/syslog/log.XLATE");
#
# Read in the log file, clean the newline ('\n') off the end.
#
while (<SYSLOG>) 
	{
	chomp;
#
# Separate out the initial fields (month, date, time stamp,
# the host that generated it, and lump the rest of the message
# into one string for opcode specific parsing at a later time.
#
# @fields is structured as follows (based on syslog format):
#	$fields[0] = Three Letter month abbreviation
#	$fields[1] = Numeric date of the month
#	$fields[2] = Timestamp in 24 hours HH:MM:SS
#	$fields[3] = name of the host that generated the message 
#		     (logging host, firewall, router, etc.)
#	Format is now Source-Host specific from here on out
#	$fields[4] = Pix opcode for message category
#	$fields[5] = Rest of the message lumped into 1 string for further processing, 
#	             since this part has differing formats based on the specific opcode. 
#	             See below for more details.
	(@fields) = split (' ', $_, 6);
#print ($month," ",$date," ", $time," ", $host," ",$opcode,"\n");
#
# if the host that generated the message is the one we care about,
# then let's go through the rest of the message looking for opcodes
# that we care about, and then lump the rest of them into an
# "other" file so that we can look at that later.
#

	if ($fields[3] eq "inside-pix.cccpp.com")
		{
		(@func) = split ('-', $fields[4], 3);
		OPSWITCH:
			{
#			if ($func[2] eq "106001:") {&tcp_in_deny();}
#			if ($func[2] eq "106006:") {&tcp_in_deny();}
#			if ($func[2] eq "106007:") {&tcp_in_deny();}
#			if ($func[2] eq "106010:") {&tcp_in_deny();}
#			if ($func[2] eq "106014:") {&tcp_in_deny();}
			if ($func[2] eq "106001:") {&tcp_in_deny(); last;}
			if ($func[2] eq "106002:") {&tcp_out_deny(); last;}
			if ($func[2] eq "106003:") {&tcp_java_deny(); last;}
			if ($func[2] eq "106006:") {&udp_in_deny(); last;}
			if ($func[2] eq "106007:") {&udp_dns_in_deny(); last;}
			if ($func[2] eq "106008:") {&xlate_out_deny(); last;}
			if ($func[2] eq "106009:") {&xlate_out_dest_deny(); last;}
			if ($func[2] eq "106010:") {&generic_in_deny(); last;}
			if ($func[2] eq "106011:") {&self_route_deny(); last;}
			if ($func[2] eq "107001:") {&ping_in_deny(); last;}
			if ($func[2] eq "108001:") {&smtp_in_deny(); last;}
			if ($func[2] eq "108002:") {&smtp_in_deny(); last;}
			if ($func[2] eq "109006:") {&auth_failed(); last;}
			if ($func[2] eq "109008:") {&auth_failed(); last;}
			if ($func[2] eq "110001:") {&no_route(); last;}
			if ($func[2] eq "110002:") {&no_arp_for_host(); last;}
			if ($func[2] eq "111001:") {&generic(); last;}
			if ($func[2] eq "111004:") {&generic(); last;}
			if ($func[2] eq "111005:") {&generic(); last;}
			if ($func[2] eq "111007:") {&generic(); last;}
			if ($func[2] eq "199003:") {&reduce_link_mtu(); last;}
			if ($func[2] eq "201001:") {&out_of_connections(); last;}
			if ($func[2] eq "201002:") {&too_many_static_connections(); last;}
			if ($func[2] eq "201003:") {&embryonic_limit_exceeded(); last;}
			if ($func[2] eq "201004:") {&too_many_embryonic_connections(); last;}
			if ($func[2] eq "209001:") {&generic(); last;}
			if ($func[2] eq "307001:") {&pixadmin(); last;}
			if ($func[2] eq "307002:") {&pixadmin(); last;}
			if ($func[2] eq "307003:") {&pixadmin(); last;}
			if ($func[2] eq "308001:") {&pixadmin(); last;}
			if ($func[2] eq "309001:") {&pixadmin(); last;}
			if ($func[2] eq "309002:") {&pixadmin(); last;}
			print NETADMIN ($fields[5], "\n");
			}

		}	# End of "if ($host eq" block
}
#############################################################################################
#                                                                                           #
#                                   REPORT PRINTING                                         #
#                                                                                           #
#############################################################################################
#
# Print out results of TCPIN scans for the previous day's logs
	printf TCPIN ("\n TCP/IP INTRUSION ATTEMPTS\n");
foreach $addr (sort keys (%tcp_in_pairs))
	{
	printf TCPIN ("%5d\t%s\n",$tcp_in_pairs{$addr},$addr);
	}	# End of "foreach $addr" loop
#
# Print out results of TCPIN Auth scans for previous day's logs
	printf TCPIN ("\nAUTHENTICATION/IDENT ATTEMPTS - Generally Non-Intrusive\n");
foreach $addr (sort keys (%auth_in_pairs))
        {
        printf TCPIN ("%5d\t%s\n",$auth_in_pairs{$addr},$addr);
        }       # End of "foreach $addr" loop


# Print out results of TCPOUT scans for the previous day's logs
	printf TCPOUT ("\n TCP/IP OUTBOUND ATTEMPTS\n");
foreach $addr (sort keys (%tcp_out_pairs))
	{
	printf TCPOUT ("%5d\t%s\n",$tcp_out_pairs{$addr},$addr);
	}	# End of "foreach $addr" loop

# Print out results of UDPIN scans for the previous day's logs
	printf UDPIN ("\n UDP INBOUND ATTEMPTS\n");
foreach $addr (sort keys (%udp_in_pairs))
	{
	printf UDPIN ("%5d\t%s\n",$udp_in_pairs{$addr},$addr);
	}	# End of "foreach $addr" loop

# Print out results of SMTP errors in the previous day's logs
	printf SMTP ("\n SMTP TRANMISSION ERRORS\n");
foreach $addr (sort keys (%smtp_in_pairs))
	{
	printf SMTP ("%5d\t%s\n",$smtp_in_pairs{$addr},$addr);
	}	# End of "foreach $addr" loop

# Print out results of XLATE errors in the previous day's logs
	printf XLATE ("\n INTERNET ACCESS TRANSLATION ERRORS\n");
	foreach $addr (sort keys (%xlate_out))
	{
		printf XLATE ("%5d\t%s\n",$xlate_out{$addr},$addr);
	}	# End of "foreach $addr" loop

# Print out results of ICMP errors in the previous day's logs
	printf ICMPIN ("\n INBOUND ICMP ATTEMPTS\n");
	foreach $addr (sort keys (%ping_in))
	{
		printf ICMPIN ("%5d\t%s\n",$ping_in{$addr},$addr);
	}	# End of "foreach $addr" loop

#
# Close all open file handles
#
close (SYSLOG);
close (TCPIN);
close (TCPOUT);
close (JAVA);
close (UDPIN);
close (UDPIN);
close (ICMPIN);
close (NETADMIN);
close (SYSADMIN);
close (PIXADMIN);
close (SMTP);
close (XLATE);

exit(0);


#############################################################################################
#                                                                                           #
#                                           SUBROUTINES                                     #
#                                                                                           #
#############################################################################################
sub inbound_deny {
	#
	# Break the elements of the incoming line into the pieces we care about
	# which are the source IP address, the source port number, the destination
	# IP address, the destination port number and the TCP flags
	(@message) = split (' ', $fields[5], 20);
	@protocol = split (' ', $message[3]);
	@src_addr = split ('/', $message[5], 2);
	@dst_addr = split ('/', $message[7], 2);
	#
	# As we process each log entry, keep count of the number of source addresses
	# and packets from each, the number of destination addresses, and packets to 
	# each of them.
	#
	# Look for ident/auth requests and log them separately since we see so many of them.
	if ($dst_addr[1] eq "113") 
		{
		$auth_in_pairs{$dst_addr[0]."\t".$src_addr[0]}++;
		}
	else
		{
		$tcp_in_source{$src_addr[0]}++;
		$tcp_in_dest{$dst_addr[0]}++;
		$tcp_in_src_port{$src_addr[1]}++;
		$tcp_in_dst_port{$dst_addr[1]}++;
		$tcp_in_pairs{$dst_addr[0]."/".$dst_addr[1]."\t".$src_addr[0]}++;
	}

}	# End of "sub inbound_deny" routine

#
# Analyze outbound TCP/IP attempted connections - Report by destination IP address and then source IP
#
sub tcp_out_deny {
	(@message) = split (' ', $fields[5], 20);
	#
	# Break the elements of the incoming line into the pieces we care about
	# which are the source IP address, the source port number, the destination
	# IP address, the destination port number and the TCP flags
	# message[8] = IP Src addr, message[9]=IP Src port
	# message[11]= IP Dst addr, message[12]=IP Dst port
	
	#
	# As we process each log entry, keep count of the number of source addresses
	# and packets from each, the number of destination addresses, and packets to 
	# each of them.
	#
	$tcp_out_src_addr{$message[8]}++;
	$tcp_out_dest{$message[11]}++;
	$tcp_out_src_port{$message[9]}++;
	$tcp_out_dst_port{$message[12]}++;
	$tcp_dst_pairs=sprintf("%-15s\t%-15s",$message[11], $message[8]);
#	$tcp_out_pairs{$message[11]."\t".$message[8]}++;
	$tcp_out_pairs{$tcp_dst_pairs}++;
}	# End of "sub tcp_out_deny" routine
#
#
sub tcp_java_deny {
print JAVA ($fields[5],"\n");
}
#
#
sub udp_in_deny {
	(@message) = split (' ', $fields[5], 20);
        #
        # Break the elements of the incoming line into the pieces we care about
        # which are the source IP address, the source port number, the destination
        # IP address, the destination port number and the TCP flags
        # message[8] = IP Src addr, message[9]=IP Src port
        # message[11]= IP Dst addr, message[12]=IP Dst port
        
        #
        # As we process each log entry, keep count of the number of source addresses
        # and packets from each, the number of destination addresses, and packets to
        # each of them.
        #
        $udp_in_src_addr{$message[8]}++;
        $udp_in_dest{$message[11]}++;
	@src_addr = split ('/', $message[4], 2);
	@dst_addr = split ('/', $message[6], 2);
        $udp_in_source{$src_addr[0]}++;
        $udp_in_dest{$dst_addr[0]}++;
        $udp_in_src_port{$src_addr[1]}++;
        $udp_in_dst_port{$dst_addr[1]}++;
	$udp_dst_addr=sprintf("%-15s/%-4s",$dst_addr[0], $dst_addr[1]);
        $udp_in_pairs{$udp_dst_addr."\t".$src_addr[0]}++;
	}       # End of "sub udp_in_deny" routine

#
#
sub udp_dns_in_deny {
}
#
# Translation for 198.95.87.155 denied by outbound 1
# PIX error #106008
sub xlate_out_deny {
	(@message) = split (' ', $fields[5], 20);
	$xlate_out{$message[2]}++
}
#
# Translation for 198.95.84.192 to 172.19.4.21 denied by outbound 2
# PIX error #106009
sub xlate_out_dest_deny {
	(@message) = split (' ', $fields[5], 20);
	$xlate_out{$message[2]."\t".$message[4]}++
}
#
#
sub  pixadmin {
# PIX Error Codes PIX-3-307001, 307002, 307003, 308001, 309001, 309002 
#
	(@message) = split (' ', $fields[5], 20);
	$protocol=$message[3];
	$source=$message[5];
	$destination=$message[7];
	$generic_in{$message[3]."\t".$message[5]."\t".$message[7]}++

}
#
#
sub generic_in_deny {
# PIX Error Code PIX-3-106010: 
# Deny inbound protocol 171 src outside:209.1.224.151 dst inside:198.95.93.116 
	(@message) = split (' ', $fields[5], 20);
	$protocol=$message[3];
	$source=$message[5];
	$destination=$message[7];
	$generic_in{$message[3]."\t".$message[5]."\t".$message[7]}++

}
#
#
sub self_route_deny {
        (@message) = split (' ', $fields[5], 20);
	print SYSADMIN ($fields[5],"\n");
}
#
#
sub ping_in_deny {
# PIX error code: 107001: 
# Msg: 199.94.208.76 attempted to ping 205.227.213.73 (198.95.85.112)
	(@message) = split (' ', $fields[5], 20);
	$ping_in_pair=sprintf("%-15s\t%-15s",$message[0], $message[4]);
	$ping_in{$ping_in_pair}++
#	$ping_in{$message[0]."\t".$message[4]}++
}
#
#
sub auth_failed {
print SYSADMIN ($fields[5],"\n");
}
#
#
sub no_route {
}
#
#
sub no_arp_for_host {
}
#
#
sub smtp_in_deny {
        (@message) = split (' ', $fields[5], 20);
        #
        # Break the elements of the incoming line into the pieces we care about
        # which are the source IP address, the source port number, the destination
        # IP address, the destination port number and the TCP flags
        # message[8] = IP Src addr, message[9]=IP Src port
        # message[11]= IP Dst addr, message[12]=IP Dst port

        #
        # As we process each log entry, keep count of the number of source addresses
        # and packets from each, the number of destination addresses, and packets to
        # each of them.
        #
        $src_addr=$message[6];
        $dst_addr=$message[4];
	$smtp_pairs=sprintf("%-15s\t%-15s",$dst_addr,$src_addr);
        $smtp_in_pairs{$smtp_pairs}++;
#	$smtp_in_pairs{$dst_addr."\t".$src_addr}++;
}	# End of "sub smtp_in_deny" routine}
#
#
sub reduce_link_mtu {
}
#
#
sub out_of_connections {
}
#
#
sub too_many_static_connections {
}
#
#
##############################################
# Holding area for un-implemented subroutines
##############################################
sub generic {
print NETADMIN ($fields[5],"\n");
}
